#include <windows.h>
#include <stdlib.h>
#define WINDOW_TITLE "Dimke Kill Screensaver"
#define TIMER_NUMBER 1

LONG FAR PASCAL WndProc(HWND, UINT, UINT, LONG);

int TimerSec;

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow) {
	HWND hwnd;
	MSG msg;
	WNDCLASS wndclass;

	if(FindWindow(NULL, WINDOW_TITLE)) {
		MessageBox(NULL, "Already one instance of this process running!", WINDOW_TITLE, MB_OK | MB_ICONSTOP);
		return(1);
	}

	TimerSec= atoi(lpszCmdLine);
	if(TimerSec<1) {
		MessageBox(NULL, "Wrong timeout value!", WINDOW_TITLE, MB_OK | MB_ICONSTOP);
		return(1);
	}

	wndclass.style = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc = WndProc;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon (hInstance, "SCREENSAVER");
	wndclass.hCursor = LoadCursor (NULL , IDC_ARROW);
	wndclass.hbrBackground = GetStockObject (LTGRAY_BRUSH);
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = WINDOW_TITLE;
	RegisterClass (&wndclass);

	hwnd = CreateWindow (WINDOW_TITLE,WINDOW_TITLE,WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,
			CW_USEDEFAULT,640,480,NULL,NULL,hInstance,NULL);

	SetTimer(hwnd, TIMER_NUMBER, 1000, NULL);

	while(GetMessage(&msg, NULL, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam ;
}


LONG FAR PASCAL WndProc (HWND hwnd , UINT message , UINT wParam , LONG lParam) {
	static int TimerEventCounter=0;
	static char lpszClassName[127], lpszScrClassName[]="WindowsScreenSaverClass";

	HWND hwnd_ActiveWindow;

	switch (message){
		case WM_TIMER:		{
			if(wParam==TIMER_NUMBER) {
				TimerEventCounter++;
				if(TimerEventCounter == TimerSec) {
					hwnd_ActiveWindow=GetActiveWindow();
					GetClassName(hwnd_ActiveWindow, lpszClassName, 127);
					if(lstrcmp(lpszClassName,lpszScrClassName)==0) {
						PostMessage(hwnd_ActiveWindow, WM_QUIT, 0, 0);
					}
					PostQuitMessage(0);
				}
			}
			break;
		}
		case WM_DESTROY:	{
			KillTimer(hwnd, 0);
			PostQuitMessage(0);
		}
		return 0 ;
	}
	return DefWindowProc (hwnd , message , wParam , lParam) ;
}

